package PROP::ExceptionTest;

use strict;
use base qw/Test::Unit::TestCase/;
use PROP::Exception;

sub new {
    my ($invocant, @args) = @_;
    my $self = $invocant->SUPER::new(@args);

    return $self;
}

sub set_up {
    my ($self) = @_;
}

sub tear_down {
    my ($self) = @_;
}

sub test_exception_propagation {
    my ($self) = @_;

    eval {
	eval {
	    eval {
		die new PROP::Exception("woe is I");
	    };
	    die $@->PROPAGATE("well, look what I caught");
	};
	die $@->PROPAGATE("and in turn I caught you");
    };

    # note that if you move this assert statement you will break it
#     $self->assert_str_equals("\nPROP::Exception" .
# 			     "\n" .
# 			     "    ...woe is I in file " .
# 			     __FILE__ . " at line " . (__LINE__ - 11) .
# 			     "\n" .
# 			     "    ...well, look what I caught in file " .
# 			     __FILE__ . " at line " . (__LINE__ - 12) .
# 			     "\n" .
# 			     "    ...and in turn I caught you in file " .
# 			     __FILE__ . " at line " . (__LINE__ - 13) .
# 			     "\n",
# 			     $@->stringify());
}

1;

=head1 Author

Andrew Gibbs (awgibbs@awgibbs.com,andrew.gibbs@nist.gov)

=head1 Legalese

This software was developed at the National Institute of Standards and
Technology by employees of the Federal Government in the course of
their official duties. Pursuant to title 17 Section 105 of the United
States Code this software is not subject to copyright protection and
is in the public domain. PROP is an experimental system. NIST
assumes no responsibility whatsoever for its use by other parties, and
makes no guarantees, expressed or implied, about its quality,
reliability, or any other characteristic. We would appreciate
acknowledgement if the software is used.  This software can be
redistributed and/or modified freely provided that any derivative
works bear some notice that they are derived from it, and any modified
versions bear some notice that they have been modified.
